<?php
namespace App\Http\Controllers\Home;

use App\Http\Controllers\Controller;
use App\Services\MigrationService;
use Illuminate\Http\Request;
use \Symfony\Component\HttpKernel\Exception\HttpException;

class MigrationController extends Controller
{
    /**
     * 安装程序首页
     */
    public function index(){
        if($this->isLocked()){
            throw new HttpException(404, 'Page Not Found');
        }
        return view('migration.index');
    }

    public function init(Request $request){
        if($this->isLocked()){
            throw new HttpException(404, 'Page Not Found');
        }
        try {
            $res = (new MigrationService())->init($request);
            return $this->ajaxSuccess('', $res);
        }catch (\Exception $ex){
            return  $this->ajaxError($ex->getMessage());
        }
    }

    public function migrate(Request $request){
        if($this->isLocked()){
            throw new HttpException(404, 'Page Not Found');
        }
        try {
            $res = (new MigrationService())->migrate($request);
            return $this->ajaxSuccess('', $res);
        }catch (\Exception $ex){
            return  $this->ajaxError($ex->getMessage());
        }
    }
    public function finished(){
        if($this->isLocked()){
            throw new HttpException(404, 'Page Not Found');
        }
        try {
            unlink(__FILE__);
            file_put_contents(storage_path('install/migration.lock'), 'LOCK;' . date('YmdHis'));
            return $this->ajaxSuccess('');
        }catch (\Exception $ex){
            return  $this->ajaxError($ex->getMessage());
        }
    }

    private function isLocked(){
        return is_file(storage_path('install/migration.lock'));
    }
}
