<?php
/**
 * 域名交易价格迁移数据解析
 * User: lzs
 * Date: 2020/11/30
 * Time: 16:33
 * Brand: ePower
 */

namespace App\Services\Migration\Prices;


use App\Models\DtProduct;
use App\Models\Price;
use Illuminate\Database\ConnectionInterface;

class DomainTrade
{
    public static function parse($price, ConnectionInterface $connection)
    {
        // 获取对应产品
        $product = $connection->table('dt_products')->where('pid', $price->pdid)->first();
        if (!$product){
            return false;
        }
        if (DtProduct::query()->where('identity', $product->pid)->doesntExist()){
            return false;
        }

        // 数据处理
        $collection = [
            'discount' => [
                'value' => bcmul($price->type_value, 100, 0),
                'type' => Price::TYPE_DISCOUNT,
            ],
        ];

        return ['product_id' => $product->pid, 'collection' => $collection];
    }
}