<?php
/**
 * 企业邮箱价格迁移数据解析
 * User: lzs
 * Date: 2020/11/30
 * Time: 16:19
 * Brand: ePower
 */

namespace App\Services\Migration\Prices;


use App\Models\Price;
use App\Models\XwEmailProduct;
use Illuminate\Database\ConnectionInterface;

class EtpEmail
{
    public static function parse($price, ConnectionInterface $connection)
    {
        // 获取对应产品
        $product = $connection->table('enterprise_email_products')->where('product_id', $price->pdid)->first();
        if (!$product){
            return false;
        }
        if (XwEmailProduct::query()->where('identity', $product->product_id)->doesntExist()){
            return false;
        }

        // 数据处理
        $buyPrice = [
            'value' => bcmul($price->price_year_1, 100, 0),
            'type' => Price::TYPE_UNIT,
        ];
        $renewPrice = [
            'value' => bcmul($price->price_year_renew_1, 100, 0),
            'type' => Price::TYPE_UNIT,
        ];
        $collection = [
            'buy' => $buyPrice,
            'renew' => $renewPrice,
        ];

        return ['product_id' => $product->product_id, 'collection' => $collection];
    }
}