<?php
/**
 * 官微建站价格迁移数据解析
 * User: lzs
 * Date: 2020/11/30
 * Time: 14:57
 * Brand: ePower
 */

namespace App\Services\Migration\Prices;


use App\Models\GwProduct;
use App\Models\Price;
use Illuminate\Database\ConnectionInterface;

class GwWeb
{
    public static function parse($price, ConnectionInterface $connection)
    {
        // 获取对应产品
        $product = $connection->table('gw_products')->where('id', $price->pdid)->first();
        if (!$product){
            return false;
        }
        if (GwProduct::query()->where('identity', $product->type)->doesntExist()){
            return false;
        }

        // 数据处理
        $collection = [];
        switch ($product->type){
            case 'basic':
            case 'social_official':
            case 'social_mall':
            case 'portal':
            case 'saas_enterprise_edition':
            case 'saas_new_retail':
                $collection = [
                    'buy' => [
                        'value' => bcmul($price->price_year_1, 100, 0),
                        'type' => Price::TYPE_UNIT,
                    ],
                    'renew' => [
                        'value' => bcmul($price->price_year_renew_1, 100, 0),
                        'type' => Price::TYPE_UNIT,
                    ],
                ];
                break;
            case 'copyright':
                $collection = [
                    'buy' => [
                        'value' => bcmul($price->price_year_1, 100, 0),
                        'type' => Price::TYPE_FIXED,
                    ],
                ];
                break;
            case 'domain':
                $collection = [
                    'buy' => [
                        'value' => bcmul($price->type_value, 100, 0),
                        'type' => Price::TYPE_UNIT,
                    ],
                ];
                break;
            case 'icp':
                $collection = [
                    'buy' => [
                        'value' => bcmul($price->type_value, 100, 0),
                        'type' => Price::TYPE_UNIT,
                    ],
                ];
                break;
            case 'agent_construction':
                $collection = [
                    'buy' => [
                        'value' => bcmul($price->type_value, 100, 0),
                        'type' => Price::TYPE_FIXED,
                    ],
                ];
                break;
        }

        return ['product_id' => $product->type, 'collection' => $collection];
    }
}