<?php
/**
 * 云服务器价格迁移数据解析
 * User: lzs
 * Date: 2020/11/30
 * Time: 14:50
 * Brand: ePower
 */

namespace App\Services\Migration\Prices;


use App\Models\Price;
use App\Models\ServerLine;
use Illuminate\Database\ConnectionInterface;

class Server
{
    public static function parse($price, ConnectionInterface $connection)
    {
        // 获取对应产品
        $product = $connection->table('server_line')->where('id', $price->pdid)->first();
        if (!$product){
            return false;
        }
        if (ServerLine::query()->where('identity', $product->id)->doesntExist()){
            return false;
        }

        // 数据处理
        $collection = [
            'discount' => [
                'value' => bcmul($price->type_value, 100, 0),
                'type' => Price::TYPE_DISCOUNT,
            ],
        ];

        return ['product_id' => $product->id, 'collection' => $collection];
    }
}