<?php
/**
 * 商标交易 价格迁移数据解析
 * User: lzs
 * Date: 2020/11/30
 * Time: 15:33
 * Brand: ePower
 */

namespace App\Services\Migration\Prices;


use App\Models\Price;
use App\Models\TmProduct;
use App\Models\TmtProduct;
use Illuminate\Database\ConnectionInterface;

class TmTrade
{
    public static function parse($price, ConnectionInterface $connection)
    {
        // 获取对应产品
        $product = $connection->table('products_tmjiaoyi')->where('id', $price->pdid)->first();
        if (!$product){
            return false;
        }
        if (TmtProduct::query()->where('identity', $product->pid)->doesntExist()){
            return false;
        }

        // 数据处理
        if ($product->pid == 'service'){
            $collection = [
                'buy' => [
                    'value' => bcmul($price->type_value, 100, 0),
                    'type' => Price::TYPE_FIXED,
                ],
            ];

            return ['product_id' => $product->pid, 'collection' => $collection];
        }
        $collection = [
            'discount' => [
                'value' => bcmul($price->type_value, 100, 0),
                'type' => Price::TYPE_DISCOUNT,
            ],
        ];

        return ['product_id' => $product->pid, 'collection' => $collection];
    }
}