<?php
/**
 * 云虚拟主机价格迁移数据解析
 * User: lzs
 * Date: 2020/11/30
 * Time: 15:55
 * Brand: ePower
 */

namespace App\Services\Migration\Prices;


use App\Models\Price;
use App\Models\VhostPackage;
use Illuminate\Database\ConnectionInterface;

class Vhost
{
    public static function parse($price, ConnectionInterface $connection)
    {
        // 获取对应产品
        $product = $connection->table('host_product')->where('pId', $price->pdid)->first();
        if (!$product){
            return false;
        }
        if (VhostPackage::query()->where('identity', $product->pId)->doesntExist()){
            return false;
        }

        // 数据处理
        $collection = [
            'discount' => [
                'value' => bcmul($price->type_value, 100, 0),
                'type' => Price::TYPE_DISCOUNT,
            ],
        ];

        return ['product_id' => $product->pId, 'collection' => $collection];
    }
}