<!DOCTYPE>
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <script src="/statics/epower/libs/vue.min.js"></script>
    <link rel="stylesheet" href="/statics/epower/libs/element-ui/theme/index.css">
    <script src="/statics/epower/libs/element-ui/index.js"></script>
    <script type="text/javascript" src="/statics/install/lib/framework/jquery/jquery-1.12.2.min.js"></script>
    <!-- <script type="text/javascript" src="/statics/install/lib/common-ajax-dialog-eson-ejs.js"></script> -->
    <!-- <link href="/statics/install/common/dialog.css" type="text/css" rel="stylesheet" /> -->
    <link rel="stylesheet" href="/statics/install/common/style.css">
    <title>ePower企服引擎V2</title>
    <style>
        body .el-message-box__wrapper {
            top: -250px;
        }

        body .el-message-box__wrapper .error-alert {
            margin-top: 250px;
        }

        .el-message-box__wrapper .error-alert {
            width: 800px;
        }

        .el-message {
            top: 264px !important;
        }

        #tables-list {
            margin-top: 10px;
        }



        #tables-list a {
            border: 1px #ddd solid;
            background-color: #f6f6f6;
            display: inline-block;
            padding: 5px 10px;
            margin-bottom: 5px
        }
    </style>
</head>

<body>
    <div class="container" id="app">
        <el-dialog :title="errorTitle||'系统提示'" :visible.sync="errorDialog" width="60%" center top="100px">
            <div style="height:360px;line-height:24px;">
                <el-scrollbar>
                    <div v-html="errorHtml">
                    </div>
                </el-scrollbar>
            </div>

            <span slot="footer">
                <el-button type="primary" v-on:click="errorDialog=false;" size="medium">确定</el-button>
            </span>
        </el-dialog>
        <div class="header" style="height: auto !important;">
            <div class="headerTop">
                <h1 class="upgrade">ePower企服引擎V2升级向导</h1>
            </div>
        </div>
        <div class="main">
            <form method="post" onsubmit="return false;" name="form-install-info">
                <div id="form_items_3">
                    <br>
                    <div class="desc" style="font-weight: bold">填写<span style="color: red">原数据库</span>信息</div>
                    <table class="tb2">
                        <tbody>
                            <tr>
                                <th class="tbopt" align="left">&nbsp;数据库服务器:</th>
                                <td>
                                    <input type="text" name="host" value="127.0.0.1" />
                                </td>
                                <td>数据库服务器地址, 一般为 127.0.0.1</td>
                            </tr>

                            <tr>
                                <th class="tbopt" align="left">&nbsp;数据库名:</th>
                                <td>
                                    <input type="text" name="database" value="" />
                                </td>
                                <td></td>
                            </tr>

                            <tr>
                                <th class="tbopt" align="left">&nbsp;数据库用户名:</th>
                                <td>
                                    <input type="text" name="username" value="" />
                                </td>
                                <td></td>
                            </tr>

                            <tr>
                                <th class="tbopt" align="left">&nbsp;数据库密码:</th>
                                <td>
                                    <input type="password" name="password" value="" />
                                </td>
                                <td></td>
                            </tr>
                            <tr>
                                <th class="tbopt" align="left">&nbsp;数据库端口:</th>
                                <td>
                                    <input type="text" name="port" value="3306" />
                                </td>
                                <td>数据库端口，数据库服务连接端口，一般为3306</td>
                            </tr>
                            <tr>
                                <th class="tbopt" align="left">&nbsp;</th>
                                <td>
                                    <a href="javascript:void(0)" v-on:click="databaseTest(null)">测试数据库连接</a>
                                </td>
                                <td>&nbsp;</td>
                            </tr>
                        </tbody>
                    </table>
                </div>
                <div class="btnbox marginbot">
                    <a href="javascript:void(0)"> <input type="button" v-on:click="upgrade" value="一键升级" class="hover"></a>
                    <!-- <div id="tables-list">
                        <template v-if="tables.length">
                            <a v-for="(row,index) in tables" :key="index" href="javascript:void(0)" v-on:click="installSingle(row)">@{{row}} </a>
                        </template>
                    </div> -->
                </div>
            </form>
        </div>
    </div>

    <script>
        var start = new Date();
        var upgradeMsg = null
        new Vue({
            el: '#app',
            data: function() {
                return {
                    tables: [],
                    errorHtml: '',
                    errorTitle: '',
                    errorDialog: false
                }
            },
            methods: {
                pull: function() {
                    var that = this
                    this.databaseTest(function() {});
                },
                databaseTest: function databaseTest(cb) {
                    var that = this
                    var _message = that.$message({
                        type: 'info',
                        message: '正在连接数据库...',
                        duration: 0
                    })
                    var data = $('form[name="form-install-info"]').serialize()
                    $.ajax({
                        url: '/migration/init',
                        type: 'POST',
                        data: data,
                        dataType: 'json',
                        complete: function() {
                            _message.close()
                        },
                        error: function() {
                            that.$alert('请求错误，连接失败', '系统提示', {
                                confirmButtonText: '确定',
                                type: 'error',
                            })
                        },
                        success: function(res) {
                            if (!res) {
                                that.$alert('请求错误，连接失败', '系统提示', {
                                    confirmButtonText: '确定',
                                    type: 'error',
                                })
                                return;
                            }
                            if (res.result) {
                                if (!cb) {
                                    that.$alert('数据库连接成功，可继续进行升级！', '系统提示', {
                                        confirmButtonText: '确定',
                                        type: 'success',
                                    })
                                }
                                that.tables = res.data;
                                cb && cb();
                                return;
                            }
                            that.errorTitle = '数据库连接失败'
                            that.errorHtml = '数据库连接失败：<span style="color:gray;">' + res.message + '</span>'
                            that.errorDialog = true
                        }
                    });
                },
                upgrade: function () {
                    var that = this
                    that.$confirm('确定执行升级程序吗？', '升级', {
                        confirmButtonText: '立即升级',
                        cancelButtonText: '取消',
                        type: 'warning'
                    }).then(function() {
                        that.databaseTest(function() {
                            var tables_ = that.tables;
                            if (tables_.length === 0) {
                                that.$alert('安装包异常，请重新从官网下载', '系统提示', {
                                    confirmButtonText: '确定',
                                    type: 'error'
                                })
                                return;
                            }
                            window['upgradeMsg'] = that.$message({
                                type: 'info',
                                dangerouslyUseHTMLString: true,
                                duration: 0,
                                message: '<p>正在升级，请勿关闭浏览器<span id="timer"></span>...</p>' +
                                    '<p id="install-process" style="margin-top: 15px;"></p>'
                            })
                            start = new Date();
                            that.nextStep(tables_, 0);
                            return false;
                        });
                    })
                },
                nextStep: function (tables, index) {
                    var that = this
                    if (index > 0) {
                        var timeUsed = (new Date() - start);
                        timeLeft = timeUsed * tables.length / index;
                        $('#timer').html('(预计剩余：' + (timeLeft / 1000).toFixed(2) + '秒)');
                    }
                    if (tables.length === 0) {
                        window['upgradeMsg'].close()
                        that.$alert('升级完成，请检查数据是否准确！', '升级完成', {
                            confirmButtonText: '完成升级',
                            type: 'success',
                        }).then(function(){
                            that.finish()
                        })
                        return;
                    }
                    that.installTable(tables, tables.shift(), index, 1);
                },
                installTable: function (tables, tableName, index, page) {
                    var that = this
                    $('#install-process').html('正在升级数据库[' + tableName + ']...');
                    $.ajax({
                        url: '/migration/migrate?type=' + tableName + '&page=' + page,
                        type: 'POST',
                        data: {},
                        dataType: 'json',
                        error: function() {
                            window['upgradeMsg'].close()
                            that.$alert('数据库升级失败', '系统提示', {
                                confirmButtonText: '确定',
                                type: 'error'
                            })
                        },
                        success: function(res) {
                            if (!res) {
                                window['upgradeMsg'].close()
                                that.$alert('数据库升级失败', '系统提示', {
                                    confirmButtonText: '确定',
                                    type: 'error'
                                })
                                return;
                            }
                            if (res.result) {
                                if (res.data.is_finished) {
                                    that.nextStep(tables, index + 1);
                                } else {
                                    that.installTable(tables, tableName, index, page + 1);
                                }
                                return;
                            }
                            window['upgradeMsg'].close()
                            that.errorTitle = '数据库升级失败'
                            that.errorHtml = '数据库升级失败：<span style="color:gray; ">' + res.message + '</span>'
                            that.errorDialog = true
                        }
                    });
                },
                installSingle: function (name) {
                    var that = this
                    window['upgradeMsg'] = that.$message({
                        type: 'info',
                        dangerouslyUseHTMLString: true,
                        duration: 0,
                        message: '<p>正在升级，请稍候<span id="timer"></span>...</p>' +
                            '<p id="install-process" style="margin-top: 15px;"></p>'
                    })
                    this.installTableSingle(name, 1);
                },
                installTableSingle: function (tableName, page) {
                    var that = this
                    $('#install-process').html('正在升级数据库[' + tableName + '][第' + page + '页]...');
                    $.ajax({
                        url: '/migration/migrate?type=' + tableName + '&page=' + page,
                        type: 'POST',
                        data: {},
                        dataType: 'json',
                        error: function() {
                            window['upgradeMsg'].close()
                            that.$alert('数据库升级失败', '系统提示', {
                                confirmButtonText: '确定',
                                type: 'error'
                            })
                        },
                        success: function(res) {
                            if (!res) {
                                window['upgradeMsg'].close()
                                that.$alert('数据库升级失败', '系统提示', {
                                    confirmButtonText: '确定',
                                    type: 'error'
                                })
                                return;
                            }
                            if (res.result) {
                                if (res.data.is_finished) {
                                    window['upgradeMsg'].close()
                                    that.$alert('升级完成！', '系统提示', {
                                        confirmButtonText: '确定',
                                        type: 'success',
                                    })
                                } else {
                                    installTableSingle(tableName, page + 1);
                                }
                                return;
                            }
                            window['upgradeMsg'].close()
                            that.errorTitle = '数据库升级失败'
                            that.errorHtml = '数据库升级失败：<span style="color:gray;">' + res.message + '</span>'
                            that.errorDialog = true
                        }
                    });
                },
                finish: function () {
                    var that = this
                    this.$confirm('确定升级程序已经全部完成吗？', '系统提示', {
                        confirmButtonText: '确认',
                        cancelButtonText: '取消',
                        type: 'warning'
                    }).then(function() {
                        window['upgradeMsg'] = that.$message({
                            type: 'info',
                            dangerouslyUseHTMLString: true,
                            duration: 0,
                            message: '<p id="install-process">正在完成升级</p>'
                        })
                        $.ajax({
                            url: '/migration/finished',
                            type: 'GET',
                            dataType: 'json',
                            error: function() {
                                window['upgradeMsg'].close()
                                that.$alert('完成失败，请手动删除升级程序', '系统提示', {
                                    confirmButtonText: '确定',
                                    type: 'error',
                                })
                            },
                            success: function(res) {
                                if (!res) {
                                    window['upgradeMsg'].close()
                                    that.$alert('完成失败，请手动删除升级程序', '系统提示', {
                                        confirmButtonText: '确定',
                                        type: 'error',
                                    })
                                    return;
                                }
                                if (res.result) {
                                    window['upgradeMsg'].close()
                                    that.$alert('完成成功！', '系统提示', {
                                        confirmButtonText: '确定',
                                        type: 'success',
                                    }).then(function(){
                                        // TODO 默认先跳转 admin
                                        location.href = '/'
                                    })
                                    return;
                                }
                                window['upgradeMsg'].close()
                                that.$alert('完成失败，请手动删除升级程序', '系统提示', {
                                    confirmButtonText: '确定',
                                    type: 'error',
                                })
                            }
                        });
                    })
                }
            },
        })
    </script>
</body>

</html>
